c Graph experiment, inspect, VF and SR
c SYMMETRIC lalocs
c collimated detectors - graphical presentation of isolines
c modified laloc (using cubic splines)
c
      character *8 file
      dimension c(500,6),val(4)
      write(*,*)'file'
      read(*,'(a)')file
      call rea(file,nn,c,smc,svf,ssr,hvf,acol,amed)
      do i=1,nn
         write(*,1)(c(i,j),j=1,5)
1        format(5e10.3)
      enddo
      m=4
      h=0.03
      d=0.014
      call graf(file,c,nn,m,h,d,val,smc,svf,ssr,hvf,acol,amed)
      end

      subroutine graf(file,c,nc,m,h,d,val,smc,svf,ssr,hvf,acol,amed)
c
c C(n-point | r,z,exp,vf,sr)
c H-thickness of collimator
c D-aperture of collimator
c
      dimension r(90,4),z(90,4),rg(300),zg(300),
     /          c(500,6),ca(500,6),val(4)
      character *7 text,method(4)
      character *8 file
      character *29 label,line
      data method/'EXPER. ','INSPECT','View F.','SR     '/
      write(*,*)' Text line'
      read(*,'(a)')line
      call gmfin
      rmax=0.06
      zmax=0.15
      zmin=-0.07
      call gmfont(2,'h18w9rb    ')
      do iwin=1,4
        call gmfstf(1,.25*(iwin-1),.25*iwin,0.,1.,
     /              -rmax,rmax, zmin, zmax)
        call gmfsw(1)  
        call gmfrec(-rmax,rmax,0.,zmax,1)
        call gmfill(0.,zmax/2,16,1)
        call gmftext(-rmax*.9,zmax,0,7,method(iwin))
        call gmfrec(-rmax,rmax,zmin,0.,1)
        call gmfill(0.,zmin/2,16,1)
        ncc=0
        do i=1,nc
           if(c(i,1).ge.0..and.c(i,iwin+2).ge.0.)then
              ncc=ncc+1
              do j=1,6
                 ca(ncc,j)=abs(c(i,j))
              enddo
           endif
        enddo
        call caliso(ca,ncc,iwin,r,z,n,m,val)
        do ig=1,m
          call curve(ig,d,r,z,n,rg,zg,ng)    
          call gmfplf(ng,rg,zg,10,10+ig)
          if(ig.le.m.and.iwin.eq.1)then
             write(text,205)val(ig)
205          format(f5.0,' %')
             call gmftext(0.,zg(ng/2+1),0,7,text)
          endif
        enddo
        if(iwin.eq.4)then
           do ig=1,ncc
              call gmfmrk(ca(ig,1),ca(ig,2),20)
           enddo
        endif
c z-lines
        dr=rmax/10.
        rg(1)=-rmax
        zg(1)=0.05
        zg(2)=0.05
        do i=1,20
           rg(1)=rg(1)+dr
           rg(2)=rg(1)+dr*.7
           zg(1)=0.05
           zg(2)=0.05
           call gmfpl(2,rg,zg,11)
           zg(1)=0.1
           zg(2)=0.1
           call gmfpl(2,rg,zg,11)
        enddo
c draw collimator
        botc=amax1(-h,zmin*.8)
        botd=zmin*.9
        call gmfrec(-rmax,rmax,botc,0.,1)
        call gmfill(0.,botc/2,12,1)
        call gmfrec(-d/2,d/2,botc,0.,1)
        call gmfill(0.,botc/2,14,1)
        call gmfrec(-d,d,botd,botc,1)
        call gmfill(0.,(botc+botd)/2,13,1)
        do iq=1,1000
          rt=rnd(idum)
          rt=rt**4
          zt=rnd(idum)
          rg(1)=d*(1.9*rt-.97)
          rg(2)=rg(1)
          zg(1)=botd+zt*(botc-botd)
          zg(2)=zg(1)
          call gmfpl(2,rg,zg,0)
        enddo
        do iq=1,2000
          rt=rnd(idum)
          rt=1-rt**4
          zt=rnd(idum)
          rg(1)=d*(1.9*rt-.97)
          rg(2)=rg(1)
          zg(1)=botd+zt*(botc-botd)
          zg(2)=zg(1)
          call gmfpl(2,rg,zg,16)
        enddo
        call gmfrec(-d,d,botd,botc,0)
        rg(1)=0
        rg(2)=0
        zg(1)=zmax
        zg(2)=botd
        rg(3)=0.001
        zg(3)=botd-0.002
        rg(4)=0.002
        zg(4)=botd-0.003
        rg(5)=0.003
        zg(5)=botd-0.0032
        rg(6)=0.005
        zg(6)=botd-0.0032
        rg(7)=0.007
        zg(7)=botd-0.0025
        rg(8)=0.008
        zg(8)=botd-0.002
        call gmfpl(8,rg,zg,0)
        rg(1)=-d/2
        zg(1)=-h
        rg(2)=2*d
        zg(2)=h*1.5
        call gmfpl(2,rg,zg,16)
        rg(1)=d/2
        zg(1)=-h
        rg(2)=-2*d
        zg(2)=h*1.5
        call gmfpl(2,rg,zg,16)
        if(iwin.eq.1)then
           write(text,200)d
200        format('d=',f5.3)
           call gmftext(0.,-h,0,7,text)
           write(text,201)h
201        format('h=',f5.3)
           call gmftext(-rmax*.9,-h,0,7,text)
        endif
      enddo
      call gmfont(2,'h10w5rb    ')
      call gmfstf(1,0.45,0.8, 0.035, 0.13, 0.,1.,0.,1.3)
      call gmfsw(1)
      call gmfrec(0.,1.,0.,1.3,11)
      call gmfill(0.5,0.5,16,11)
      call gmftext(.05,1.3,0,29,line)
      write(label,300)svf,hvf/h,amed
300   format('VF',f4.1,'% He/H=',f4.2,' a=',f4.0,'[1/m]')
      call gmftext(.05,1.,0,29,label)
      write(label,301)ssr,acol
301   format('SR',f4.1,'% acollimator=',f4.0,'[1/m]')
      call gmftext(.05,.7,0,29,label)
      write(label,302)smc
302   format('MC',f4.1'%')
      call gmftext(.05,.4,0,7,label)
      call gmfend
c
c----axial
      smax=0
      smin=1e10
      do iw=3,6
      do i=1,nc
        ci=c(i,iw)
        if(ci.ge.0.)then
          smax=amax1(smax,ci)
          smin=amin1(smin,ci)
        endif
      enddo
      enddo
      call gmfin
      call gmfont(2,'h18w9rb    ')
      call gmfste(1,0.,1.,0.,1.,0.,zmax,smin,smax)
      call gmfsyl('z',1,file,8)
      call gmfaxe(1,7,0)
      call gmfmrk(zmax*.3,smax,10)
      call gmftext(zmax*.3,smax,16,7,method(1))
      call gmfmrk(zmax*.5,smax,21)
      call gmftext(zmax*.5,smax,16,7,method(2))
      call gmfmrk(zmax*.7,smax,22)
      call gmftext(zmax*.7,smax,16,7,method(3))
      call gmfmrk(zmax*.9,smax,23)
      call gmftext(zmax*.9,smax,16,7,method(4))
      do i=1,nc
         if(c(i,1).eq.0.)then
           call gmfmrk(c(i,2),c(i,3),10)
           call gmfmrk(c(i,2),c(i,4),21)
           call gmfmrk(c(i,2),c(i,5),22)
           call gmfmrk(c(i,2),c(i,5),23)
         endif
      enddo
      call gmfend
      end

      subroutine curve(ig,d,r,z,n,ra,za,na)
      dimension r(90,4),z(90,4),ra(100),za(100)
      ra(1)=d/2
      za(1)=-0.001
      na=1
      do i=1,n
         ri=r(i,ig)
         zi=z(i,ig)
         if(ri.gt.0.)then
            na=na+1
            ra(na)=ri
            za(na)=zi
         elseif(ri.lt.0.)then
            na=na+1
            ra(na)=0
            za(na)=-ri
            goto 1
         else
            goto 1
         endif
      enddo
c mirroring ra,za(na-points)
1     continue
      do i=1,na-1
      ra(na+i)=-ra(na-i)
      za(na+i)=za(na-i)
      enddo
      na=2*na-1
      end     


      subroutine caliso(c,n,iwin,r,z,nz,m,valv)
c
c Input: c(n,6)  (r,z,exp,inspect,vf,sr)
c        m-number of isolines
c Output: r(nz,m),z(nz,m)
c        nz-number of interpolated points
c
      dimension c(500,6),r(90,4),z(90,4),valv(4)
      dimension zl(90),nrl(90),izr(90,30)
      valv(1)=10
      valv(2)=20
      valv(3)=30
      valv(4)=50
      call zlist(c,n,zl,nz)
      call rlist(c,n,zl,nz,izr,nrl)
c value of isolines
      smax=0
      do i=1,n
        smax=amax1(smax,c(i,iwin+2))
      enddo
      do ig=1,m
         sval=valv(ig)*smax/100.
           do iz=1,nz
              z(iz,ig)=zl(iz)
              caxnew=c(izr(iz,1),iwin+2)
              if(nrl(iz).eq.1.or.caxnew.lt.sval)then
                 r(iz,ig)=0
                 if(iz.gt.1)then
c last value of r(...) is in fact Z on axis with negative sign
                    caxold=c(izr(iz-1,1),iwin+2)
                    if(caxold.ge.sval)then
                      r(iz,ig)=-(zl(iz-1)+
     /                 (sval-caxold)*(zl(iz)-zl(iz-1))/(caxnew-caxold))
                    endif
                 endif
              else
                 rold=0
                 vold=c(izr(iz,1),iwin+2)
                 do ir=2,nrl(iz)
                   ic=izr(iz,ir)
                   rnew=c(ic,1)
                   vnew=c(ic,iwin+2)
                   if(vnew.le.sval.or.ir.eq.nrl(iz))then
                      if(vnew.eq.vold)then
                         r(iz,ig)=rnew
                      else
                         r(iz,ig)=rold+
     /                             (rnew-rold)*(sval-vold)/(vnew-vold)
                      endif
                      goto 2
                   endif
                   rold=rnew
                   vold=vnew
                 enddo
 2               continue
              endif
           enddo
      enddo
      end

      subroutine rlist(c,n,zl,nz,izr,nrl)
      dimension c(500,6),zl(90),nrl(90),izr(90,30)
      logical sort
      do iz=1,nz
         z=zl(iz)
         nrl(iz)=0
         do i=1,n
            if(c(i,2).eq.z)then
               nrl(iz)=nrl(iz)+1
               izr(iz,nrl(iz))=i
            endif
         enddo
c
c sort according to r
         nr=nrl(iz)
1        sort=.true.
         do i=1,nr-1
            if(c(izr(iz,i),1).gt.c(izr(iz,i+1),1))then
               sort=.false.
               iaux=izr(iz,i)
               izr(iz,i)=izr(iz,i+1)
               izr(iz,i+1)=iaux
            endif
         enddo
         if(.not.sort)goto 1
      enddo
      end

      subroutine zlist(c,n,zl,nz)
      dimension c(500,6),zl(90)
      logical sort
      nz=0
      do i=1,n
         cz=c(i,2)
         do j=1,nz
           if(cz.eq.zl(j))goto 1
         enddo
         nz=nz+1
         zl(nz)=cz
1        continue
      enddo
c sort zl
2     sort=.true.
      do i=1,nz-1
       if(zl(i).gt.zl(i+1))then
          sort=.false.
          aux=zl(i)
          zl(i)=zl(i+1)
          zl(i+1)=aux
       endif
      enddo
      if(.not.sort)goto 2
      end

      subroutine rea(file,n,c,smc,svf,ssr,hvf,acol,amed)
      character *8 file
      dimension c(500,6)
      open(1,file=file//'.out')
      read(1,*)n
      write(*,1)n
1     format(32x,i3)
      read(1,*)
      do i=1,n
         read(1,*)(c(i,j),j=1,6)
      enddo
      read(1,*)
      read(1,*)
      read(1,*)
      read(1,2)smc
2     format(7x,f7.2)
      read(1,3)svf,hvf
      write(*,3)svf,hvf
3     format(7x,f7.2,f10.5)
      read(1,4)ssr,acol,amed
      write(*,4)ssr,acol,amed
4     format(7x,f7.2,10x,f14.2,f10.2)
      end
