c
c processing data from POINLnn.OUT
c
      dimension h(200),d(200),dvf(200,6),dsr(200,6),hef(200,6),
     /          hd(200),x(200),y(200),isel(200),xl(200),yl(200),
     /          xg(2),yg(2)
      character *8 file(200),text,texn,texr
      character *12 ilist,flist
      character *5 ytext(4)
      character *1 fc,tc
      dimension iv(5)
      common /scom/iss(50)
      equivalence (iv(1),norm),(iv(2),text),(iv(4),hmin),(iv(5),iplot)
      data ytext/'Hef/H','Errs%','ErVF%','ErSR%'/
      data ilist/'poinl*.out  '/
      norm=1
      text='tc?????w'
      iplot=1
      call scomin(0)
1000  call sclear
      call scdark(31)
      call minpf(0,'File',4,10,10,ilist,12,9,25,10,flist,12,ires)
      if(ires.gt.0)then
        open(1,file=flist)
      else
        stop
      endif
      ndat=1
1     do inorm=1,4
         read(1,2,end=100,err=100)texr,devs,hefs
2        format(a8,9x,f7.2,f10.5)
         dvf(ndat,inorm)=devs
         hef(ndat,inorm)=hefs
         read(1,3)dsr(ndat,inorm),h(ndat),acol,a
3        format(17x,f7.2,f10.5,f14.2,f10.2)
      enddo
c averages
      dvf(ndat,5)=(dvf(ndat,1)+dvf(ndat,3))/2.
      dsr(ndat,5)=(dsr(ndat,1)+dsr(ndat,3))/2.
      hef(ndat,5)=(hef(ndat,1)+hef(ndat,3))/2.
      dvf(ndat,6)=0
      dsr(ndat,6)=0
      hef(ndat,6)=0
      do inorm=1,4
         dvf(ndat,6)=dvf(ndat,6)+dvf(ndat,inorm)/4
         dsr(ndat,6)=dsr(ndat,6)+dsr(ndat,inorm)/4
         hef(ndat,6)=hef(ndat,6)+hef(ndat,inorm)/4
      enddo   
      file(ndat)=texr
      read(texr,5,err=100)ids
5     format(4x,i2)
      if(ids.eq.5)then
         d(ndat)=0.0048
      else
         d(ndat)=ids*0.001
      endif
      hd(ndat)=h(ndat)/d(ndat)
      ndat=ndat+1
      goto 1
100   ndat=ndat-1
      if(ndat.le.2)then
         write(*,*)' Number of data points is only',ndat
         write(*,*)' Data in point.out cannot contain tcexp...'
      endif
101   call sclear
      call scdark(31)
      call minpv(0,flist,12,5,10,
     /' File: @2a8     (F1-new file)                           '//
     /' Norm: @1i4 0(all),1,2,3,4,5=aver(1+3),6=aver(1+2+3+4)  '//
     /' Plot: @5i4 1-(VF+SR),  2-(VF),  3-(SR)  0-Hef/H        '//
     /' Hmin: @4f8.3   [m] (only data for H>Hmin are selected) ',
     /4,14,iv)
      if(iss(13).eq.27)then
          call sclear
          stop
      elseif(iss(13).eq.59)then
          goto1000
      endif
      if(norm.eq.0)then
        n1=1
        n2=4
      elseif(norm.ge.1.and.norm.le.6)then
        n1=norm
        n2=norm
      endif
      select case(iplot)
      case(1)
        ipl1=1
        ipl2=2
      case(3)
        ipl1=2
        ipl2=2
      case default
        ipl1=1
        ipl2=1
      end select
c
      nsel=0
      do i=1,ndat
         if(hmin.ge.h(i))goto 104
         write(*,*)text,file(i)
         do j=1,8
           tc=text(j:j)
           fc=file(i)(j:j)
           if(tc.eq.'*')goto 103
           if(tc.ne.'?'.and.tc.ne.fc)goto 104
         enddo
103      nsel=nsel+1
         isel(nsel)=i
104   enddo
      if(nsel.le.0)goto 101
      xmin=0.
      xmax=10.
      ymin=0.
      ymax=1.5
106   do igra=1,2
      call gmfin
      call gmfont(2,'h18w9rb    ')
      call gmfste(1,0.,1.,0.,1.,xmin,xmax,ymin,ymax)
      call gmfsyl('H/D',3,ytext(iplot+1),5)
      call gmfaxe(1,7,0)
      yg(1)=1
      yg(2)=1
      xg(1)=xmin
      xg(2)=xmax
      call gmfdash(2,xg,yg,14,xmax-xmin,ymax-ymin,50)
c a/a axis
      call gmfont(2,'h10w5rb    ')
      xmin=1e10
      ymin=1e10
      xmax=0.
      ymax=0.
      do inorm=n1,n2
      do ipl=ipl1,ipl2
        do i=1,nsel
           is=isel(i)
           x(i)=hd(is)
           if(iplot.eq.0)then
              y(i)=hef(is,inorm)/hd(is)
           elseif(ipl.eq.1)then
              y(i)=dvf(is,inorm)
           else
              y(i)=dsr(is,inorm)
           endif
           xmin=amin1(xmin,x(i))
           ymin=amin1(ymin,y(i))
           xmax=amax1(xmax,x(i))
           ymax=amax1(ymax,y(i))
           if(d(is).le.0.005)then
              mark=20
           elseif(d(is).le.0.015)then
              mark=21
           else
              mark=10
           endif
           call gmfmrk(x(i),y(i),mark)
           if(y(i).gt.4..and.inorm.eq.n1.and.ipl.eq.ipl1)
     /          call gmftext(x(i),y(i),16,8,file(is))
        enddo
        call sort(nsel,x,y)
        if(ipl.eq.1)then
           call gmfpl(nsel,x,y,10+inorm)
        else
           call gmfdash(nsel,x,y,10+inorm,xmax-xmin,ymax-ymin,50)
        endif
        write(texn,105)inorm
105     format('Norm',i2)
        do k=nsel-1,1,-1
           if(x(k).lt.x(nsel))goto 119
        enddo
119     xtt=(x(nsel)+x(k))/2.
        ytt=(y(nsel)+y(k))/2.
        call gmftext(xtt,ytt,10+inorm,6,texn)
      enddo
      enddo
      enddo
      call gmfont(2,'h14w8rb    ')
      call gmfstf(1,.3,.975,.95,1.,0.,10.,0.,1.2)
      call gmfsw(1)
      call gmfrec(0.,10.,0.,1.2,11)
      call gmfill(1.,1.,14,11)
      call gmftext(.2,.9,0,10,'['//text//']')
      call gmfmrk(4.,1.,20)
      call gmftext(4.,1.,0,7,'D=4.8mm')
      call gmfmrk(6.,1.,21)
      call gmftext(6.,1.,0,6,'D=14mm')
      call gmfmrk(8.,1.,10)
      call gmftext(8.,1.,0,6,'D=30mm')
      call gmfend
c log/log
      call gmfin
      call gmfont(2,'h18w9rb    ')
      call gmfste(1,0.,1.,0.,1.,
     /       alog10(xmin),alog10(xmax),alog10(ymin),alog10(ymax))
      call gmfsyl('H/D',3,ytext(iplot+1),5)
      call gmfaxe(1,4,0)
c log/log axis
      call gmfont(2,'h10w5rb    ')
      do inorm=n1,n2
      do ipl=ipl1,ipl2
        do i=1,nsel
          is=isel(i)
          x(i)=hd(is)
          if(ipl.eq.1)then
              y(i)=dvf(is,inorm)
          else
              y(i)=dsr(is,inorm)
          endif
          xl(i)=alog10(x(i))
          yl(i)=alog10(y(i))
          if(d(is).le.0.005)then
             mark=20
          elseif(d(is).le.0.015)then
             mark=21
          else
             mark=10
          endif
          call gmfmrk(xl(i),yl(i),mark)
          if(inorm.eq.n1.and.ipl.eq.ipl1)
     /          call gmftext(xl(i),yl(i),16,4,file(is)(3:6))
        enddo
        call sort(nsel,xl,yl)
        if(ipl.eq.1)then
          call gmfpl(nsel,xl,yl,10+inorm)
        else
          xmx=alog10(xmax)-alog10(xmin)
          ymx=alog10(ymax)-alog10(ymin)
          call gmfdash(nsel,xl,yl,10+inorm,xmx,ymx,50)
        endif
        write(texn,105)inorm
        do k=nsel-1,1,-1
           if(xl(k).lt.xl(nsel))goto 129
        enddo
129     xtt=(xl(nsel)+xl(k))/2.
        ytt=(yl(nsel)+yl(k))/2.
        call gmftext(xtt,ytt,10+inorm,6,texn)
      enddo
      enddo
      call gmfont(2,'h14w8rb    ')
      call gmfstf(1,.3,.975,.95,1.,0.,10.,0.,1.2)
      call gmfsw(1)
      call gmfrec(0.,10.,0.,1.2,11)
      call gmfill(1.,1.,14,11)
      call gmftext(.2,.9,0,10,'['//text//']')
      call gmfmrk(4.,1.,20)
      call gmftext(4.,1.,0,7,'D=4.8mm')
      call gmfmrk(6.,1.,21)
      call gmftext(6.,1.,0,6,'D=14mm')
      call gmfmrk(8.,1.,10)
      call gmftext(8.,1.,0,6,'D=30mm')
      call gmfend
      goto 101
      end

      subroutine sort(n,x,y)
      dimension x(1),y(1)
      logical s
1     s=.true.
      do i=1,n-1
        if(x(i).gt.x(i+1))then
           s=.false.
           a=x(i)
           x(i)=x(i+1)
           x(i+1)=a           
           a=y(i)
           y(i)=y(i+1)
           y(i+1)=a
        endif
      enddo
      if(.not.s)goto1
      end

